<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="工位" prop="orgId">
        <el-tree-select
          v-model="formData.orgId"
          :data="organizationTree"
          :props="defaultProps"
          check-strictly
          default-expand-all
          placeholder="请选择工位"
        />

      </el-form-item>
      <el-form-item label="班别" prop="groupType">
        <el-radio-group v-model="formData.groupType">
          <el-radio
            v-for="dict in getIntDictOptions(DICT_TYPE.MES_GROUP_TYPE)"
            :key="dict.value"
            :label="dict.value"
            @change="handleSelectChange"
          >
            {{ dict.label }}
          </el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="工作日期" prop="planDates">
        <el-date-picker
          v-model="formData.planDates"
          value-format="YYYY-MM-DD HH:mm:ss"
          type="dates"
          placeholder="请选择工作日期"
          class="!w-300px"
        />
      </el-form-item>
      <el-form-item v-if="formData.groupType" label="工人" prop="workerId">
        <el-select
          v-model="formData.workerId"
          clearable
          filterable
          placeholder="请选择工人"
          class="!w-240px"
        >
          <el-option
            v-for="item in userList"
            :key="item.id"
            :label="item.nickname"
            :value="item.id"
          />
        </el-select>
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { getIntDictOptions, DICT_TYPE } from '@/utils/dict'
import { OrgWorkerApi, OrgWorkerVO } from '@/api/mes/orgworker'
import {defaultProps, handleTree} from "@/utils/tree";
import {OrganizationApi} from "@/api/mes/organization";
import {WorkTeamApi} from "@/api/mes/workteam";
import * as UserApi from "@/api/system/user";

/** 工位安排 表单 */
defineOptions({ name: 'OrgWorkerForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗
const organizationTree = ref() // 树形结构
const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改

const userList = ref<UserApi.UserVO[]>([]) // 用户列表
const formData = ref({
  id: undefined,
  orgId: undefined,
  workDate: undefined,
  groupType: undefined,
  workerId: undefined,
  reportId: undefined,
  planDates:[]
})
const formRules = reactive({
  orgId: [{ required: true, message: '工位不能为空', trigger: 'blur' }],
  workDate: [{ required: true, message: '工作日期不能为空', trigger: 'blur' }],
  groupType: [{ required: true, message: '班别不能为空', trigger: 'blur' }],
  workerId: [{ required: true, message: '工人不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await OrgWorkerApi.getOrgWorker(id)
    } finally {
      formLoading.value = false
    }
  }
  await getOrganizationTree()
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as OrgWorkerVO
    if (formType.value === 'create') {
      await OrgWorkerApi.getCreateWorker(data)
      message.success(t('common.createSuccess'))
    } else {
      await OrgWorkerApi.updateOrgWorker(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    orgId: undefined,
    workDate: undefined,
    groupType: undefined,
    workerId: undefined,
    reportId: undefined
  }
  formRef.value?.resetFields()
}
/** 获得产线工位树 */
const getOrganizationTree = async () => {
  organizationTree.value = []
  const data = await OrganizationApi.getOrganizationList()
  const root: Tree = { id: 0, name: 'ALL', children: [] }
  root.children = handleTree(data, 'id', 'parentId')
  organizationTree.value.push(root)
}

/** 工序类型变化，可选负责人跟着变化 */
const handleSelectChange = async () => {
  // if(formData.value.orgId && formData.value.groupType){
  //   // 获得用户列表
  //   userList.value = await WorkTeamApi.getUserList2(formData.value.orgId, formData.value.groupType)
  // }
  if(formData.value.groupType){
    // 获得用户列表
    userList.value = await WorkTeamApi.getUserList2(1, formData.value.groupType)
  }
}
</script>
